## MLNX_OFED_LINUX-5.4-3.7.5.0-rhel7.9-x86_64.tgz

=== src/ofa_kernel-5.4/drivers/base/Makefile ===
obj-$(CONFIG_AUXILIARY_BUS) += auxiliary.o

=== src/ofa_kernel-5.4/drivers/nvme/Makefile ===
# SPDX-License-Identifier: GPL-2.0-only
# Retpoline support: check if this is the right architecture and that
# the kernel does not support it already.
# Alternatively, if we are called from the main mlnx-ofa build system,
# CONFIG_RETPOLINE will be set by the configure script, however
# subdir-ccflags-y will be set by the toplevel Makefile.
ifneq (,$(findstring $(ARCH),i386 x86_64))
  ifndef CONFIG_RETPOLINE
    ifneq (,$(shell awk 'BEGIN {if ($(VERSION).$(PATCHLEVEL) < 4.15) {print 1}}' </dev/null))
      CFLAGS_RETPOLINE=-mindirect-branch=thunk-inline -mindirect-branch-register -DRETPOLINE_MLNX
    endif
  endif
endif

# Enable retpoline support if the above holds and the compiler supports it.
ifneq (,$(CFLAGS_RETPOLINE))
  do_retpoline = $(call cc-option-yn, -mindirect-branch-register)
  subdir-ccflags-$(do_retpoline) += $(CFLAGS_RETPOLINE)
endif


obj-y		+= host/
obj-y		+= target/
obj-y		+= lpfc/

=== src/ofa_kernel-5.4/net/sched/Makefile ===
subdir-ccflags-y += -I$(src)/../../drivers/net/ethernet/mellanox/mlx5/core

obj-$(CONFIG_COMPAT_TCF_TUNNEL_KEY_MOD) += act_tunnel_key.o
obj-$(CONFIG_COMPAT_TCF_VLAN_MOD)       += act_vlan.o
obj-$(CONFIG_COMPAT_TCF_PEDIT_MOD)      += act_pedit.o

obj-$(CONFIG_COMPAT_CLS_FLOWER_MOD)     += cls_flower.o
ifneq ($(CONFIG_COMPAT_CLS_FLOWER_MOD),)
       cls_flower-y := cls_flower_compat.o
endif

obj-$(CONFIG_COMPAT_CLS_FLOWER_4_18_MOD) += cls_flower.o act_ct.o
ifneq ($(CONFIG_COMPAT_CLS_FLOWER_4_18_MOD),)
	cls_flower-y := cls_flower_4_18.o
	act_ct-y := act_ct_4_18.o
endif

=== src/ofa_kernel/default/compat/Makefile ===
obj-m += mlx_compat.o
#compat-objs :=

obj-$(CONFIG_COMPAT_FIRMWARE_CLASS) += compat_firmware_class.o
obj-$(CONFIG_COMPAT_NET_SCH_CODEL) += sch_codel.o
obj-$(CONFIG_COMPAT_NET_SCH_FQ_CODEL) += sch_fq_codel.o

mlx_compat-y += main.o

mlx_compat-$(CONFIG_COMPAT_KFIFO) += kfifo.o

mlx_compat-$(CONFIG_COMPAT_KERNEL_3_10) += compat-3.10.o
mlx_compat-$(CONFIG_COMPAT_KERNEL_3_11) += compat-3.11.o
mlx_compat-$(CONFIG_COMPAT_KERNEL_3_12) += compat-3.12.o
mlx_compat-$(CONFIG_COMPAT_KERNEL_3_13) += compat-3.13.o
mlx_compat-$(CONFIG_COMPAT_KERNEL_3_15) += compat-3.15.o
mlx_compat-$(CONFIG_COMPAT_KERNEL_3_16) += compat-3.16.o
mlx_compat-$(CONFIG_COMPAT_KERNEL_3_18) += compat-3.18.o

mlx_compat-$(CONFIG_COMPAT_KERNEL_4_1) += compat-4.1.o

mlx_compat-$(CONFIG_COMPAT_CORDIC) += cordic.o
mlx_compat-$(CONFIG_COMPAT_CRC8) += crc8.o
mlx_compat-$(CONFIG_COMPAT_FLOW_DISSECTOR) += flow_dissector.o
mlx_compat-y += string.o
mlx_compat-y += output_core.o
mlx_compat-y += idr.o
mlx_compat-y += interval_tree.o

ifndef CONFIG_64BIT
ifndef CONFIG_GENERIC_ATOMIC64
  mlx_compat-y += compat_atomic.o
endif
endif

mlx_compat-y += xz_crc32.o
mlx_compat-y += xz_dec_lzma2.o
mlx_compat-y += xz_dec_stream.o
mlx_compat-y += xz_dec_syms.o
mlx_compat-$(CONFIG_XZ_DEC_BCJ) += xz_dec_bcj.o

mlx_compat-y += mm_util.o
mlx_compat-y += uuid.o
mlx_compat-y += rhashtable.o
mlx_compat-y += ../block/blk-mq-rdma.o
mlx_compat-y += exec.o
mlx_compat-y += pci.o
mlx_compat-y += syscall.o
mlx_compat-y += mmu_notifier.o
mlx_compat-y += xarray.o
mlx_compat-y += rdma_dim.o
mlx_compat-y += dim.o
mlx_compat-y += net_dim.o
ifdef CONFIG_MLX5_CLS_ACT
mlx_compat-y += flow_offload.o
mlx_compat-y += cls_api.o
mlx_compat-$(CONFIG_COMPAT_CLS_FLOWER_4_18_MOD) += nf_flow_table_core.o nf_flow_table_offload.o
endif

mlx_compat-y += bitmap.o

=== src/ofa_kernel/default/ofed_scripts/Makefile ===
EXTRA_CFLAGS += $(OPENIB_KERNEL_EXTRA_CFLAGS) \
		$(KERNEL_MEMTRACK_CFLAGS) \
		-I$(CWD)/include \
		-I$(CWD)/drivers/infiniband/ulp/ipoib$(CONFIG_IPOIB_VERSION) \
		-I$(CWD)/drivers/infiniband/debug \
		-I$(CWD)/net/rds \
		-I$(CWD)/net/mlxdevm \
		-I$(CWD)/drivers/net/ethernet/mellanox/mlx5/core \
		-I$(CWD)/drivers/infiniband/hw/mlx5 \

ifneq (,$(CFLAGS_RETPOLINE))
# This is x86 and kernel has no retpoline support.
# Now we need to check for gcc support
ifneq (,$(shell $(CC) --target-help 2>/dev/null | grep -- -mindirect-branch=))
# The compiler supports it. Set the proper flags (inline or extern):
subdir-ccflags-y += $(CFLAGS_RETPOLINE)
endif
endif

obj-y := compat$(CONFIG_COMPAT_VERSION)/
obj-$(CONFIG_INFINIBAND)        += drivers/infiniband/
obj-$(CONFIG_INFINIBAND_IPATH)  += drivers/infiniband/hw/ipath/
obj-$(CONFIG_INFINIBAND_EHCA)   += drivers/infiniband/hw/ehca/
obj-$(CONFIG_INFINIBAND_AMSO1100)   += drivers/infiniband/hw/amso1100/
obj-$(CONFIG_MLX5_CORE)         += drivers/net/ethernet/mellanox/mlx5/core/
obj-$(CONFIG_MLXFW)             += drivers/net/ethernet/mellanox/mlxfw/
obj-$(CONFIG_MLXSW_CORE)	+= drivers/net/ethernet/mellanox/mlxsw/
obj-$(CONFIG_RDS)               += net/rds/
obj-$(CONFIG_MLXDEVM)          += net/mlxdevm/
obj-$(CONFIG_MEMTRACK)          += drivers/infiniband/debug/
obj-$(CONFIG_SUNRPC_XPRT_RDMA)  += net/sunrpc/xprtrdma/
obj-$(CONFIG_SUNRPC_XPRT_RDMA_DUMMY)  += net/sunrpc/xprtrdma/
obj-$(CONFIG_SUNRPC_XPRT_RDMA_CLIENT)  += net/sunrpc/xprtrdma/
obj-$(CONFIG_SUNRPC_XPRT_RDMA_SERVER)  += net/sunrpc/xprtrdma/
obj-$(CONFIG_NET_9P_RDMA) += net/9p/
obj-$(CONFIG_SCSI_SRP_ATTRS)    += drivers/scsi/
obj-$(CONFIG_NVME_CORE)         += drivers/nvme/host/
obj-$(CONFIG_NVME_HOST_WITHOUT_FC)      += drivers/nvme/host/
obj-$(CONFIG_NVME_HOST_WITHOUT_FC)      += drivers/nvme/target/
obj-$(CONFIG_BLK_DEV_NVME)      += drivers/nvme/host/
obj-$(CONFIG_NVME_FABRICS)      += drivers/nvme/host/
obj-$(CONFIG_NVME_FC)           += drivers/nvme/host/
obj-$(CONFIG_NVME_RDMA)         += drivers/nvme/host/
obj-$(CONFIG_NVME_TCP)          += drivers/nvme/host/
obj-$(CONFIG_NVME_MULTIPATH)    += drivers/nvme/host/
obj-$(CONFIG_NVME_HOST_DUMMY)   += drivers/nvme/host/
obj-$(CONFIG_NVME_TARGET)       += drivers/nvme/target/
obj-$(CONFIG_NVME_TARGET_LOOP)  += drivers/nvme/target/
obj-$(CONFIG_NVME_TARGET_RDMA)  += drivers/nvme/target/
obj-$(CONFIG_NVME_TARGET_TCP)   += drivers/nvme/target/
obj-$(CONFIG_NVME_TARGET_FC)    += drivers/nvme/target/
obj-$(CONFIG_NVME_TARGET_FCLOOP)  += drivers/nvme/target/
obj-$(CONFIG_NVME_TARGET_DUMMY) += drivers/nvme/target/
obj-$(CONFIG_RDMA_RXE_DUMMY)	+= drivers/infiniband/sw/rxe/
obj-$(CONFIG_SMC)		+= net/smc/
obj-$(CONFIG_SMC_DIAG)		+= net/smc/
obj-$(CONFIG_MLX5_CLS_ACT)      += net/sched/
obj-$(CONFIG_AUXILIARY_BUS)     += drivers/base/
obj-$(CONFIG_CIFS_SMB_DIRECT)		+= fs/cifs/
obj-$(CONFIG_MLX5_VDPA_NET)	+= drivers/vdpa/mlx5/

=== src/ofa_kernel-5.4/drivers/infiniband/core/Makefile ===
# SPDX-License-Identifier: GPL-2.0
infiniband-$(CONFIG_INFINIBAND_ADDR_TRANS)	:= rdma_cm.o
user_access-$(CONFIG_INFINIBAND_ADDR_TRANS)	:= rdma_ucm.o

obj-$(CONFIG_INFINIBAND) +=		ib_core.o ib_cm.o iw_cm.o \
					$(infiniband-y)
obj-$(CONFIG_INFINIBAND_USER_MAD) +=	ib_umad.o
obj-$(CONFIG_INFINIBAND_USER_ACCESS) += ib_uverbs.o $(user_access-y)
obj-$(CONFIG_INFINIBAND_USER_ACCESS_UCM) += ib_ucm.o

obj-$(CONFIG_INFINIBAND_CORE_DUMMY) += ib_sa.o ib_mad.o ib_addr.o

ib_sa-y :=			ib_sa_dummy.o
ib_mad-y :=			ib_mad_dummy.o
ib_addr-y :=			ib_addr_dummy.o

ib_core-y :=			packer.o ud_header.o verbs.o cq.o rw.o sysfs.o verbs_nvmf.o \
				device.o cache.o netlink.o \
				roce_gid_mgmt.o mr_pool.o addr.o sa_query.o \
				multicast.o mad.o smi.o agent.o mad_rmpp.o \
				nldev.o restrack.o counters.o ib_core_uverbs.o \
				trace.o lag.o

ib_core-$(CONFIG_SECURITY_INFINIBAND) += security.o
ib_core-$(CONFIG_CGROUP_RDMA) += cgroup.o

ib_cm-y :=			cm.o

iw_cm-y :=			iwcm.o iwpm_util.o iwpm_msg.o

CFLAGS_cma_trace.o +=		-I$(src)
rdma_cm-y :=			cma.o cma_trace.o

rdma_cm-$(CONFIG_INFINIBAND_ADDR_TRANS_CONFIGFS) += cma_configfs.o

rdma_ucm-y :=			ucma.o

ib_umad-y :=			user_mad.o

ib_ucm-y :=                     ib_ucm_dummy.o

ib_uverbs-y :=			uverbs_main.o uverbs_cmd.o uverbs_marshall.o \
				rdma_core.o uverbs_std_types.o uverbs_ioctl.o \
				uverbs_std_types_cq.o \
				uverbs_std_types_flow_action.o uverbs_std_types_dm.o \
				uverbs_std_types_mr.o uverbs_std_types_counters.o \
				uverbs_uapi.o uverbs_std_types_device.o \
				uverbs_std_types_async_fd.o \
				uverbs_std_types_srq.o \
				uverbs_std_types_wq.o \
				uverbs_std_types_qp.o


ib_core-$(CONFIG_INFINIBAND_USER_MEM) += umem.o peer_mem.o 
ib_core-$(CONFIG_INFINIBAND_ON_DEMAND_PAGING) += umem_odp.o

=== src/ofa_kernel-5.4/drivers/infiniband/hw/Makefile ===
# SPDX-License-Identifier: GPL-2.0
obj-$(CONFIG_INFINIBAND_MTHCA)		+= mthca/
obj-$(CONFIG_INFINIBAND_QIB)		+= qib/
obj-$(CONFIG_INFINIBAND_CXGB3)		+= cxgb3/
obj-$(CONFIG_INFINIBAND_CXGB4)		+= cxgb4/
obj-m					+= efa/ # For SLES12 SP5 errata kernels.
obj-$(CONFIG_INFINIBAND_IRDMA)          += irdma/
obj-$(CONFIG_INFINIBAND_I40IW)		+= i40iw/
obj-$(CONFIG_MLX4_INFINIBAND)		+= mlx4/
obj-$(CONFIG_MLX5_INFINIBAND)		+= mlx5/
obj-$(CONFIG_INFINIBAND_NES)		+= nes/
obj-$(CONFIG_INFINIBAND_OCRDMA)		+= ocrdma/
obj-$(CONFIG_INFINIBAND_VMWARE_PVRDMA)	+= vmw_pvrdma/
obj-$(CONFIG_INFINIBAND_USNIC)		+= usnic/
obj-$(CONFIG_INFINIBAND_HFI1)		+= hfi1/
obj-$(CONFIG_INFINIBAND_HNS)		+= hns/
obj-$(CONFIG_INFINIBAND_QEDR)		+= qedr/
obj-$(CONFIG_INFINIBAND_BNXT_RE)	+= bnxt_re/

=== src/ofa_kernel-5.4/drivers/nvme/host/Makefile ===
# SPDX-License-Identifier: GPL-2.0

ccflags-y				+= -I$(src)
ifeq ($(CONFIG_GPU_DIRECT_STORAGE),y)
ccflags-y				+= -DCONFIG_NVFS
endif

obj-$(CONFIG_NVME_CORE)			+= nvme-core.o
obj-$(CONFIG_BLK_DEV_NVME)		+= nvme.o
obj-$(CONFIG_NVME_FABRICS)		+= nvme-fabrics.o
obj-$(CONFIG_NVME_RDMA)			+= nvme-rdma.o
obj-$(CONFIG_NVME_FC)			+= nvme-fc.o
obj-$(CONFIG_NVME_TCP)			+= nvme-tcp.o

obj-$(CONFIG_NVME_HOST_DUMMY)		+= nvme-rdma.o

# --with-nvmf-host-rdma-only
# dummy
obj-$(CONFIG_NVME_HOST_WITHOUT_FC)		+= nvme-fc.o

ifeq ($(CONFIG_NVME_HOST_DUMMY),m)
nvme-rdma-y				:= nvme-rdma_dummy.o
else
nvme-core-y				:= core.o
nvme-core-$(CONFIG_TRACING)		+= trace.o
nvme-core-$(CONFIG_NVME_MULTIPATH)	+= multipath.o
nvme-core-$(CONFIG_NVM)			+= lightnvm.o
nvme-core-$(CONFIG_BLK_DEV_ZONED)	+= zns.o
nvme-core-$(CONFIG_FAULT_INJECTION_DEBUG_FS)	+= fault_inject.o
nvme-core-$(CONFIG_NVME_HWMON)		+= hwmon.o

nvme-y					+= pci.o
ifeq ($(CONFIG_GPU_DIRECT_STORAGE),y)
nvme-y					+= nvfs-dma.o
endif

nvme-fabrics-y				+= fabrics.o

nvme-rdma-y				+= rdma.o
ifeq ($(CONFIG_GPU_DIRECT_STORAGE),y)
nvme-rdma-y				+= nvfs-rdma.o
endif

ifeq ($(CONFIG_NVME_HOST_WITHOUT_FC),m)
nvme-fc-y				+= nvme-fc_dummy.o
else
nvme-fc-y				+= fc.o
endif

nvme-tcp-y				+= tcp.o

endif

# these 2 drivers depend on nvme-fc, so replace them with dummy drivers
ifneq ($(filter m,$(CONFIG_NVME_FC) $(CONFIG_NVME_HOST_WITHOUT_FC)),)
obj-$(CONFIG_SCSI_QLA_FC) += qla2xxx.o
qla2xxx-y := qla2xxx_dummy.o

obj-$(CONFIG_TCM_QLA2XXX) += tcm_qla2xxx.o
tcm_qla2xxx-y := tcm_qla2xxx_dummy.o
endif

=== src/ofa_kernel-5.4/drivers/nvme/target/Makefile ===
# SPDX-License-Identifier: GPL-2.0

ccflags-y				+= -I$(src)
obj-$(CONFIG_NVME_TARGET)		+= nvmet.o
obj-$(CONFIG_NVME_TARGET_LOOP)		+= nvme-loop.o
obj-$(CONFIG_NVME_TARGET_RDMA)		+= nvmet-rdma.o
obj-$(CONFIG_NVME_TARGET_FC)		+= nvmet-fc.o
obj-$(CONFIG_NVME_TARGET_FCLOOP)	+= nvme-fcloop.o
obj-$(CONFIG_NVME_TARGET_TCP)		+= nvmet-tcp.o

obj-$(CONFIG_NVME_TARGET_DUMMY) += nvmet-rdma.o

# --with-nvmf-host-rdma-only
# dummy
obj-$(CONFIG_NVME_HOST_WITHOUT_FC)		+= nvmet.o
obj-$(CONFIG_NVME_HOST_WITHOUT_FC)		+= nvme-loop.o
obj-$(CONFIG_NVME_HOST_WITHOUT_FC)		+= nvmet-rdma.o
obj-$(CONFIG_NVME_HOST_WITHOUT_FC)		+= nvmet-fc.o
obj-$(CONFIG_NVME_HOST_WITHOUT_FC)		+= nvme-fcloop.o

ifeq ($(CONFIG_NVME_TARGET_DUMMY),m)
nvmet-rdma-y	+= nvmet-rdma_dummy.o
else
ifeq ($(CONFIG_NVME_HOST_WITHOUT_FC),m)
nvmet-y		+= nvmet_dummy.o
nvme-loop-y	+= nvme-loop_dummy.o
nvmet-rdma-y	+= nvmet-rdma_dummy.o
nvmet-fc-y	+= nvmet-fc_dummy.o
nvme-fcloop-y	+= nvme-fcloop_dummy.o
else
nvmet-y		+= core.o configfs.o admin-cmd.o fabrics-cmd.o \
			discovery.o io-cmd-file.o io-cmd-bdev.o
nvmet-$(CONFIG_NVME_TARGET_PASSTHRU)	+= passthru.o
nvme-loop-y	+= loop.o
nvmet-rdma-y	+= rdma.o
nvmet-fc-y	+= fc.o
nvme-fcloop-y	+= fcloop.o
nvmet-tcp-y	+= tcp.o
nvmet-$(CONFIG_TRACING)	+= trace.o
endif
endif

=== src/ofa_kernel-5.4/net/sunrpc/xprtrdma/Makefile ===
# SPDX-License-Identifier: GPL-2.0

# Retpoline support: check if this is the right architecture and that
# the kernel does not support it already.
# Alternatively, if we are called from the main mlnx-ofa build system,
# CONFIG_RETPOLINE will be set by the configure script, however
# subdir-ccflags-y will be set by the toplevel Makefile.
ifneq (,$(findstring $(ARCH),i386 x86_64))
  ifndef CONFIG_RETPOLINE
    ifneq (,$(shell awk 'BEGIN {if ($(VERSION).$(PATCHLEVEL) < 4.15) {print 1}}' </dev/null))
      CFLAGS_RETPOLINE=-mindirect-branch=thunk-inline -mindirect-branch-register -DRETPOLINE_MLNX
    endif
  endif
endif

# Enable retpoline support if the above holds and the compiler supports it.
ifneq (,$(CFLAGS_RETPOLINE))
  do_retpoline = $(call cc-option-yn, -mindirect-branch-register)
  subdir-ccflags-$(do_retpoline) += $(CFLAGS_RETPOLINE)
endif

ifeq ($(CONFIG_GPU_DIRECT_STORAGE),y)
ccflags-y				+= -DCONFIG_NVFS
endif

obj-$(CONFIG_SUNRPC_XPRT_RDMA) += rpcrdma.o

obj-$(CONFIG_SUNRPC_XPRT_RDMA_DUMMY) += rpcrdma.o
obj-$(CONFIG_SUNRPC_XPRT_RDMA_DUMMY) += xprtrdma.o
obj-$(CONFIG_SUNRPC_XPRT_RDMA_DUMMY) += svcrdma.o
obj-$(CONFIG_SUNRPC_XPRT_RDMA_CLIENT) += xprtrdma.o
obj-$(CONFIG_SUNRPC_XPRT_RDMA_SERVER) += svcrdma.o
xprtrdma-y := xprtrdma_dummy.o
svcrdma-y := svcrdma_dummy.o

ifeq ($(CONFIG_SUNRPC_XPRT_RDMA_DUMMY),m)
rpcrdma-y := rpcrdma_dummy.o
else
rpcrdma-y := transport.o rpc_rdma.o verbs.o \
	frwr_ops.o \
	svc_rdma.o svc_rdma_backchannel.o svc_rdma_transport.o \
	svc_rdma_sendto.o svc_rdma_recvfrom.o svc_rdma_rw.o \
	module.o

ifeq ($(CONFIG_GPU_DIRECT_STORAGE),y)
rpcrdma-y += nvfs_rpc_rdma.o
endif

rpcrdma-$(CONFIG_SUNRPC_BACKCHANNEL) += backchannel.o
endif

=== src/ofa_kernel-5.4/drivers/infiniband/hw/irdma/Makefile ===
obj-m += irdma.o

irdma-y := main.o

=== src/ofa_kernel-5.4/drivers/infiniband/hw/mlx5/Makefile ===
# SPDX-License-Identifier: GPL-2.0-only
obj-$(CONFIG_MLX5_INFINIBAND) += mlx5_ib.o

mlx5_ib-y := ah.o \
	     cmd.o \
	     cong.o \
	     counters.o \
	     cq.o \
	     doorbell.o \
	     gsi.o \
	     ib_virt.o \
	     mad.o \
	     main.o \
	     main_ext.o \
	     mem.o \
	     mr.o \
	     nvmf.o  \
	     qp.o \
	     qpc.o \
	     qp_nvmf.o  \
	     restrack.o \
	     srq.o \
	     srq_cmd.o \
	     srq_nvmf.o \
	     wr.o

mlx5_ib-$(CONFIG_INFINIBAND_ON_DEMAND_PAGING) += odp.o
mlx5_ib-$(CONFIG_MLX5_ESWITCH) += ib_rep.o
mlx5_ib-$(CONFIG_INFINIBAND_USER_ACCESS) += devx.o \
					    fs.o \
					    qos.o \
					    std_types.o

=== src/ofa_kernel-5.4/debian/changelog ===
mlnx-ofed-kernel (5.4-OFED.5.4.3.7.5.1) unstable; urgency=low

  * Initial release (Closes: #125306)

 -- Vladimir Sokolovsky <vlad@mellanox.com>  Mon, 31 Dec 2012 15:38:53 +0200

=== src/ofa_kernel-5.4/debian/control ===
Source: mlnx-ofed-kernel
Section: net
Priority: optional
Maintainer: Vladimir Sokolovsky <vlad@mellanox.com>
Build-Depends: debhelper (>= 8.0.0), autotools-dev, bzip2, dkms,
Standards-Version: 3.9.2
Homepage: http://www.mellanox.com/page/products_dyn?product_family=26&mtag=linux_sw_drivers

Package: mlnx-ofed-kernel-utils
Architecture: any
Depends: ${misc:Depends}, coreutils, pciutils, grep, procps, module-init-tools | kmod, lsof,
 mlnx-tools (>= 5.2.0),
Conflicts: mlnx-en-utils
Description: Userspace tools to restart and tune mlnx-ofed kernel modules

Package: mlnx-ofed-kernel-dkms
Section: kernel
Architecture: all
Depends: dkms, make, ${misc:Depends}, coreutils, pciutils, grep, procps, module-init-tools | kmod, lsof, mlnx-ofed-kernel-utils,
Recommends: linux-headers-arm64 | linux-headers-powerpc | linux-headers-ppc64 | linux-headers-ppc64le | linux-headers-amd64 | linux-headers-generic | linux-headers
Provides: mlnx-rdma-rxe-dkms
Conflicts: mlnx-rdma-rxe-dkms
Replaces: mlnx-rdma-rxe-dkms
Description: DKMS support for mlnx-ofed kernel modules
 This package provides integration with the DKMS infrastructure for
 automatically building out of tree kernel modules.
 .
 This package provides the source code for the mlnx-ofed kernel modules.
 .
 This package contains the source to be built with dkms.

=== src/ofa_kernel/default/ofed_scripts/mlnx_en/debian/control ===
Source: mlnx-en
Section: net
Priority: optional
Maintainer: Vladimir Sokolovsky <vlad@mellanox.com>
Build-Depends: debhelper (>= 8.0.0), autotools-dev, bzip2, dkms,
Standards-Version: 3.9.2
Homepage: http://www.mellanox.com/page/products_dyn?product_family=26&mtag=linux_sw_drivers

Package: mlnx-en-utils
Architecture: any
Depends: ${misc:Depends}, coreutils, pciutils, grep, procps, module-init-tools | kmod,
 mlnx-tools (>= 5.2.0),
Conflicts: mlnx-ofed-kernel-utils
Description: Userspace tools to restart and tune mlnx-ofed kernel modules

Package: mlnx-en-dkms
Section: kernel
Architecture: all
Depends: dkms, make, ${misc:Depends}, coreutils, pciutils, grep, procps, module-init-tools | kmod, mlnx-en-utils,
Recommends: linux-headers-arm64 | linux-headers-powerpc | linux-headers-ppc64 | linux-headers-ppc64le | linux-headers-amd64 | linux-headers-generic | linux-headers
Description: DKMS support for mlnx-ofed kernel modules
 This package provides integration with the DKMS infrastructure for
 automatically building out of tree kernel modules.
 .
 This package provides the source code for the mlnx-ofed kernel modules.
 .
 This package contains the source to be built with dkms.

=== src/ofa_kernel-5.4/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# This version is for a hypothetical package that can build a kernel modules
# architecture-dependant package via make-kpkg, as well as an
# architecture-independent module source package, and other packages
# either dep/indep for things like common files or userspace components
# needed for the kernel modules.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

WITH_DKMS ?= 1
WITH_MOD_SIGN ?= 0
MLXNUMC = $(shell grep ^processor /proc/cpuinfo | wc -l)
NJOBS ?= $(shell if [ $(MLXNUMC) -lt 16 ]; then echo $(MLXNUMC); else echo 16; fi)

pname:=mlnx-ofed-kernel
psource:=$(pname)-source
ifeq ($(WITH_DKMS),1)
pdkms:=$(pname)-dkms
else
pdkms:=$(pname)-modules
endif
putils:=$(pname)-utils

pversion := $(shell dpkg-parsechangelog | sed -n 's/^Version: *\([^-]\+\)-.\+/\1/p')
prel := $(shell dpkg-parsechangelog | sed -n 's/^Version: *\([^-]\+\)-\(.\+\)/\2/p')

export INSTALL_MOD_DIR:=updates
export INSTALL_MOD_PATH:=$(CURDIR)/debian/$(pdkms)

DIST_NAME := $(shell lsb_release -si)
DIST_RELEASE := $(DIST_NAME)/$(shell lsb_release -sc)

kernelver ?= $(shell uname -r)
kernelver1 = $(shell echo $(kernelver) | sed -e 's/_/-/g')
kernel_source_dir ?= "/lib/modules/$(kernelver)/build"

%:
ifeq ($(WITH_DKMS),1)
	dh $@ --with dkms
else
	dh $@
endif

override_dh_auto_clean:

override_dh_auto_configure:
	# backup clean sources
	/bin/rm -rf source || true
	mkdir -p source
	ls -1 | grep -v source | xargs -iELEM cp ELEM -r source
ifneq ($(WITH_DKMS),1)
	@echo Building for $(kernelver)
	find compat -type f -exec touch -t 200012201010 '{}' \; || true
	$(CURDIR)/configure --kernel-version=$(kernelver) --kernel-sources=$(kernel_source_dir) $(shell $(CURDIR)/ofed_scripts/dkms_ofed $(kernelver) $(kernel_source_dir) get-config) --with-njobs=$(NJOBS)
endif

override_dh_auto_build:
ifneq ($(WITH_DKMS),1)
	make distclean || true
	make -j$(NJOBS)
endif
override_dh_auto_test:

override_dh_auto_install:
ifneq ($(WITH_DKMS),1)
	make install_modules INSTALL_MOD_DIR=$(INSTALL_MOD_DIR) INSTALL_MOD_PATH=$(INSTALL_MOD_PATH) KERNELRELEASE=$(kernelver)
	find $(INSTALL_MOD_PATH) \( -type f -a -name "modules.*" \) -delete
ifeq ($(WITH_MOD_SIGN),1)
	ofed_scripts/tools/sign-modules $(INSTALL_MOD_PATH)/lib/modules/ $(kernel_source_dir)
endif
endif


	# For dkms
	dh_installdirs -p$(pdkms)  usr/src/$(pname)-$(pversion)
	cp -a source/compat*		debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp -a source/include		debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp -a source/drivers		debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp -a source/fs			debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp -a source/net		debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp -a source/block		debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp -a source/backports		debian/$(pdkms)/usr/src/$(pname)-$(pversion) || true
	cp source/backports_applied	debian/$(pdkms)/usr/src/$(pname)-$(pversion) || true
	cp -a source/ofed_scripts	debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp -a source/COPYING		debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	$(CURDIR)/ofed_scripts/generate_dkms_conf.sh > debian/$(pdkms)/usr/src/$(pname)-$(pversion)/dkms.conf
	cd debian/$(pdkms)/usr/src/$(pname)-$(pversion); ln -s ofed_scripts/configure
	cd debian/$(pdkms)/usr/src/$(pname)-$(pversion); ln -s ofed_scripts/makefile
	cd debian/$(pdkms)/usr/src/$(pname)-$(pversion); ln -s ofed_scripts/Makefile
	cd debian/$(pdkms)/usr/src; ln -snf $(pname)-$(pversion) ofa_kernel-$(pversion)
	#
	# Sources for building stuff over MLNX_OFED
	#
	# With DKMS, copy the below files and folders during post_build since the
	# new DKMS versions started to remove the whole build directory.
	# however, some old versions of DKMS are buggy and ignores POST_BUILD
ifeq ($(WITH_DKMS),1)
	dh_installdirs -p$(pdkms)  usr/src/ofa_kernel/
	# copy the ofa-kernel build headers using ofed_scripts/pre_build.sh in the DKMS MAKE step (called from ofed_scripts/pre_build.sh).
else
	dh_installdirs -p$(pdkms)  usr/src/ofa_kernel/default
	cp -ar include/			debian/$(pdkms)/usr/src/ofa_kernel/default/
	cp -ar config*			debian/$(pdkms)/usr/src/ofa_kernel/default/
	cp -ar compat*			debian/$(pdkms)/usr/src/ofa_kernel/default/
	cp -ar ofed_scripts		debian/$(pdkms)/usr/src/ofa_kernel/default/
	cp -ar Module*.symvers		debian/$(pdkms)/usr/src/ofa_kernel/default/
endif

	# Force DKMS to install our modules.
	# This is mostly needed for modules that do not have a version number info, as DKMS
	# will compare their srcversion field, which does not really say which module is newer.
ifeq ($(WITH_DKMS),1)
	dh_installdirs -p$(pdkms)  usr/share/dkms/modules_to_force_install/
	echo "$(pname)" > debian/$(pdkms)/usr/share/dkms/modules_to_force_install/$(pname).force
endif

	# For utils
	dh_installdirs -p$(putils)  etc/infiniband
	dh_installdirs -p$(putils)  etc/modprobe.d
	dh_installdirs -p$(putils)  sbin
	dh_installdirs -p$(putils)  bin
	dh_installdirs -p$(putils)  usr/bin
	dh_installdirs -p$(putils)  usr/sbin
	dh_installdirs -p$(putils)  lib/udev
	dh_installdirs -p$(putils)  lib/systemd/system
	dh_installdirs -p$(putils)  lib/udev/rules.d
	dh_installdirs -p$(putils)  etc/init.d
	dh_installdirs -p$(putils)  etc/init
	dh_installdirs -p$(putils)  etc/systemd/system
	dh_installdirs -p$(putils)  usr/share/mlnx_ofed

	cp source/ofed_scripts/openib.conf debian/$(putils)/etc/infiniband
	cp source/ofed_scripts/mlx5.conf   debian/$(putils)/etc/infiniband
ifneq ($(WITH_DKMS),1)
	$(CURDIR)/ofed_scripts/install_helper $(CURDIR)/debian/$(putils)
endif

	install -m 0644 source/ofed_scripts/90-ib.rules   debian/$(putils)/lib/udev/rules.d
	install -m 0644 source/ofed_scripts/82-net-setup-link.rules   debian/$(putils)/lib/udev/rules.d
	install -m 0644 source/ofed_scripts/83-mlnx-sf-name.rules   debian/$(putils)/lib/udev/rules.d
	install -m 0644 ofed_scripts/openibd.service   debian/$(putils)/lib/systemd/system
	install -m 0644 ofed_scripts/mlnx_interface_mgr\@.service  debian/$(putils)/etc/systemd/system

	# Prepare /etc/infiniband/info
	echo '#!/bin/bash'						> debian/$(putils)/etc/infiniband/info
	echo								>> debian/$(putils)/etc/infiniband/info
	echo 'echo prefix=/usr'						>> debian/$(putils)/etc/infiniband/info
	echo 'echo Kernel=`uname -r`'					>> debian/$(putils)/etc/infiniband/info
	echo 'echo'							>> debian/$(putils)/etc/infiniband/info
	echo 'echo "Configure options: `/usr/src/$(pname)-$(pversion)/ofed_scripts/dkms_ofed $(kernelver) $(kernel_source_dir) get-config`"'	>> debian/$(putils)/etc/infiniband/info
	echo 'echo'							>> debian/$(putils)/etc/infiniband/info
	chmod 755 debian/$(putils)/etc/infiniband/info

	install -m 0755 source/ofed_scripts/vf-net-link-name.sh		debian/$(putils)/etc/infiniband
	install -m 0755 source/ofed_scripts/sf-rep-netdev-rename	debian/$(putils)/lib/udev
	install -m 0755 source/ofed_scripts/auxdev-sf-netdev-rename	debian/$(putils)/lib/udev
	install -m 0755 source/ofed_scripts/net-interfaces		debian/$(putils)/usr/sbin
	install -m 0755 source/ofed_scripts/ibdev2netdev		debian/$(putils)/usr/sbin
	install -m 0644 source/ofed_scripts/mlnx-ofed-kernel-utils.openibd.upstart	debian/$(putils)/etc/init/openibd.conf
	install -m 0755 source/ofed_scripts/mlnx-ofed-kernel-utils.openibd.init	debian/$(putils)/etc/init.d/openibd
	install -m 0644 source/ofed_scripts/mlnx.conf			debian/$(putils)/etc/modprobe.d
	install -m 0644 source/ofed_scripts/mlnx-bf.conf	debian/$(putils)/etc/modprobe.d
	install -m 0644 source/ofed_scripts/ib_ipoib.conf		debian/$(putils)/etc/modprobe.d
	install -m 0755 source/ofed_scripts/mlnx_interface_mgr_deb.sh	debian/$(putils)/bin/mlnx_interface_mgr.sh

=== src/ofa_kernel-5.4/drivers/infiniband/sw/rxe/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# This version is for a hypothetical package that can build a kernel modules
# architecture-dependant package via make-kpkg, as well as an
# architecture-independent module source package, and other packages
# either dep/indep for things like common files or userspace components
# needed for the kernel modules.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

WITH_DKMS ?= 1
MLXNUMC = $(shell grep ^processor /proc/cpuinfo | wc -l)
NJOBS ?= $(shell if [ $(MLXNUMC) -lt 16 ]; then echo $(MLXNUMC); else echo 16; fi)

pname:=mlnx-rdma-rxe
psource:=$(pname)-source
ifeq ($(WITH_DKMS),1)
pdkms:=$(pname)-dkms
else
pdkms:=$(pname)-modules
endif

pversion := $(shell dpkg-parsechangelog | sed -n 's/^Version: *\([^-]\+\)-.\+/\1/p')
prel := $(shell dpkg-parsechangelog | sed -n 's/^Version: *\([^-]\+\)-\(.\+\)/\2/p')

export INSTALL_MOD_DIR:=updates
export INSTALL_MOD_PATH:=$(CURDIR)/debian/$(pdkms)

DIST_NAME := $(shell lsb_release -si)
DIST_RELEASE := $(DIST_NAME)/$(shell lsb_release -sc)


KVER ?= $(shell uname -r)
KVER1 = $(shell echo $(KVER) | sed -e 's/_/-/g')
K_BUILD ?= "/lib/modules/$(KVER)/build"

%:
ifeq ($(WITH_DKMS),1)
	dh $@ --with dkms
else
	dh $@
endif

override_dh_auto_clean:

override_dh_auto_configure:

override_dh_auto_build:
ifneq ($(WITH_DKMS),1)
	@echo Building for $(KVER)
	make clean || true
	make -j$(NJOBS) KVER=$(KVER) K_BUILD=$(K_BUILD)
endif

override_dh_auto_test:

override_dh_auto_install:
ifneq ($(WITH_DKMS),1)
	make install INSTALL_MOD_DIR=$(INSTALL_MOD_DIR) INSTALL_MOD_PATH=$(INSTALL_MOD_PATH) KERNELRELEASE=$(KVER) KVER=$(KVER) K_BUILD=$(K_BUILD)
	find $(INSTALL_MOD_PATH) \( -type f -a -name "modules.*" \) -delete
endif

	# For dkms
ifeq ($(WITH_DKMS),1)
	dh_installdirs -p$(pdkms)  usr/src/$(pname)-$(pversion)
	cp Kconfig debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp makefile debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp Makefile debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp dkms.conf debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp common.postinst debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp *.c debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp *.h debian/$(pdkms)/usr/src/$(pname)-$(pversion)

	# Force DKMS to install our modules.
	# This is mostly needed for modules that do not have a version number info, as DKMS
	# will compare their srcversion field, which does not really say which module is newer.
	dh_installdirs -p$(pdkms)  usr/share/dkms/modules_to_force_install/
	echo "$(pname)" > debian/$(pdkms)/usr/share/dkms/modules_to_force_install/$(pname).force
endif

override_dh_installinit:


ifneq ($(WITH_DKMS),1)
override_dh_gencontrol:
	dh_gencontrol -- -v$(pversion)-$(prel).kver.$(KVER1)
endif

ifneq ($(MLNX_KO_NO_STRIP),1)
ifneq ($(WITH_DKMS),1)
override_dh_strip:
	dh_strip
	find debian -name '*.ko' | xargs strip -g
endif
endif

=== src/ofa_kernel-5.4/drivers/infiniband/ulp/iser/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# This version is for a hypothetical package that can build a kernel modules
# architecture-dependant package via make-kpkg, as well as an
# architecture-independent module source package, and other packages
# either dep/indep for things like common files or userspace components
# needed for the kernel modules.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

WITH_DKMS ?= 1
MLXNUMC = $(shell grep ^processor /proc/cpuinfo | wc -l)
NJOBS ?= $(shell if [ $(MLXNUMC) -lt 16 ]; then echo $(MLXNUMC); else echo 16; fi)

pname:=iser
psource:=$(pname)-source
ifeq ($(WITH_DKMS),1)
pdkms:=$(pname)-dkms
else
pdkms:=$(pname)-modules
endif

pversion := $(shell dpkg-parsechangelog | sed -n 's/^Version: *\([^-]\+\)-.\+/\1/p')
prel := $(shell dpkg-parsechangelog | sed -n 's/^Version: *\([^-]\+\)-\(.\+\)/\2/p')

export INSTALL_MOD_DIR:=updates
export INSTALL_MOD_PATH:=$(CURDIR)/debian/$(pdkms)

DIST_NAME := $(shell lsb_release -si)
DIST_RELEASE := $(DIST_NAME)/$(shell lsb_release -sc)


KVER ?= $(shell uname -r)
KVER1 = $(shell echo $(KVER) | sed -e 's/_/-/g')
K_BUILD ?= "/lib/modules/$(KVER)/build"

%:
ifeq ($(WITH_DKMS),1)
	dh $@ --with dkms
else
	dh $@
endif

override_dh_auto_clean:

override_dh_auto_configure:

override_dh_auto_build:
ifneq ($(WITH_DKMS),1)
	@echo Building for $(KVER)
	make clean || true
	make -j$(NJOBS) KVER=$(KVER) K_BUILD=$(K_BUILD)
endif

override_dh_auto_test:

override_dh_auto_install:
ifneq ($(WITH_DKMS),1)
	make install INSTALL_MOD_DIR=$(INSTALL_MOD_DIR) INSTALL_MOD_PATH=$(INSTALL_MOD_PATH) KERNELRELEASE=$(KVER) KVER=$(KVER) K_BUILD=$(K_BUILD)
	find $(INSTALL_MOD_PATH) \( -type f -a -name "modules.*" \) -delete
endif

	# For dkms
ifeq ($(WITH_DKMS),1)
	dh_installdirs -p$(pdkms)  usr/src/$(pname)-$(pversion)
	cp Kconfig debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp makefile debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp Makefile debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp dkms.conf debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp common.postinst debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp *.c debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp *.h debian/$(pdkms)/usr/src/$(pname)-$(pversion)/

	# Force DKMS to install our modules.
	# This is mostly needed for modules that do not have a version number info, as DKMS
	# will compare their srcversion field, which does not really say which module is newer.
	dh_installdirs -p$(pdkms)  usr/share/dkms/modules_to_force_install/
	echo "$(pname)" > debian/$(pdkms)/usr/share/dkms/modules_to_force_install/$(pname).force
endif

override_dh_installinit:


ifneq ($(WITH_DKMS),1)
override_dh_gencontrol:
	dh_gencontrol -- -v$(pversion)-$(prel).kver.$(KVER1)
endif

ifneq ($(MLNX_KO_NO_STRIP),1)
ifneq ($(WITH_DKMS),1)
override_dh_strip:
	dh_strip
	find debian -name '*.ko' | xargs strip -g
endif
endif

=== src/ofa_kernel-5.4/drivers/infiniband/ulp/isert/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# This version is for a hypothetical package that can build a kernel modules
# architecture-dependant package via make-kpkg, as well as an
# architecture-independent module source package, and other packages
# either dep/indep for things like common files or userspace components
# needed for the kernel modules.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

WITH_DKMS ?= 1
MLXNUMC = $(shell grep ^processor /proc/cpuinfo | wc -l)
NJOBS ?= $(shell if [ $(MLXNUMC) -lt 16 ]; then echo $(MLXNUMC); else echo 16; fi)

pname:=isert
psource:=$(pname)-source
ifeq ($(WITH_DKMS),1)
pdkms:=$(pname)-dkms
else
pdkms:=$(pname)-modules
endif

pversion := $(shell dpkg-parsechangelog | sed -n 's/^Version: *\([^-]\+\)-.\+/\1/p')
prel := $(shell dpkg-parsechangelog | sed -n 's/^Version: *\([^-]\+\)-\(.\+\)/\2/p')

export INSTALL_MOD_DIR:=updates
export INSTALL_MOD_PATH:=$(CURDIR)/debian/$(pdkms)

DIST_NAME := $(shell lsb_release -si)
DIST_RELEASE := $(DIST_NAME)/$(shell lsb_release -sc)


KVER ?= $(shell uname -r)
KVER1 = $(shell echo $(KVER) | sed -e 's/_/-/g')
K_BUILD ?= "/lib/modules/$(KVER)/build"

%:
ifeq ($(WITH_DKMS),1)
	dh $@ --with dkms
else
	dh $@
endif

override_dh_auto_clean:

override_dh_auto_configure:

override_dh_auto_build:
ifneq ($(WITH_DKMS),1)
	@echo Building for $(KVER)
	make clean || true
	make -j$(NJOBS) KVER=$(KVER) K_BUILD=$(K_BUILD)
endif

override_dh_auto_test:

override_dh_auto_install:
ifneq ($(WITH_DKMS),1)
	make install INSTALL_MOD_DIR=$(INSTALL_MOD_DIR) INSTALL_MOD_PATH=$(INSTALL_MOD_PATH) KERNELRELEASE=$(KVER) KVER=$(KVER) K_BUILD=$(K_BUILD)
	find $(INSTALL_MOD_PATH) \( -type f -a -name "modules.*" \) -delete
endif

	# For dkms
ifeq ($(WITH_DKMS),1)
	dh_installdirs -p$(pdkms)  usr/src/$(pname)-$(pversion)
	cp Kconfig debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp makefile debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp Makefile debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp dkms.conf debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp common.postinst debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp *.c debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp *.h debian/$(pdkms)/usr/src/$(pname)-$(pversion)/

	# Force DKMS to install our modules.
	# This is mostly needed for modules that do not have a version number info, as DKMS
	# will compare their srcversion field, which does not really say which module is newer.
	dh_installdirs -p$(pdkms)  usr/share/dkms/modules_to_force_install/
	echo "$(pname)" > debian/$(pdkms)/usr/share/dkms/modules_to_force_install/$(pname).force
endif

override_dh_installinit:


ifneq ($(WITH_DKMS),1)
override_dh_gencontrol:
	dh_gencontrol -- -v$(pversion)-$(prel).kver.$(KVER1)
endif

ifneq ($(MLNX_KO_NO_STRIP),1)
ifneq ($(WITH_DKMS),1)
override_dh_strip:
	dh_strip
	find debian -name '*.ko' | xargs strip -g
endif
endif

=== src/ofa_kernel-5.4/drivers/infiniband/ulp/srp/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# This version is for a hypothetical package that can build a kernel modules
# architecture-dependant package via make-kpkg, as well as an
# architecture-independent module source package, and other packages
# either dep/indep for things like common files or userspace components
# needed for the kernel modules.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

WITH_DKMS ?= 1
MLXNUMC = $(shell grep ^processor /proc/cpuinfo | wc -l)
NJOBS ?= $(shell if [ $(MLXNUMC) -lt 16 ]; then echo $(MLXNUMC); else echo 16; fi)

pname:=srp
psource:=$(pname)-source
ifeq ($(WITH_DKMS),1)
pdkms:=$(pname)-dkms
else
pdkms:=$(pname)-modules
endif

pversion := $(shell dpkg-parsechangelog | sed -n 's/^Version: *\([^-]\+\)-.\+/\1/p')
prel := $(shell dpkg-parsechangelog | sed -n 's/^Version: *\([^-]\+\)-\(.\+\)/\2/p')

export INSTALL_MOD_DIR:=updates
export INSTALL_MOD_PATH:=$(CURDIR)/debian/$(pdkms)

DIST_NAME := $(shell lsb_release -si)
DIST_RELEASE := $(DIST_NAME)/$(shell lsb_release -sc)


KVER ?= $(shell uname -r)
KVER1 = $(shell echo $(KVER) | sed -e 's/_/-/g')
K_BUILD ?= "/lib/modules/$(KVER)/build"

%:
ifeq ($(WITH_DKMS),1)
	dh $@ --with dkms
else
	dh $@
endif

override_dh_auto_clean:

override_dh_auto_configure:

override_dh_auto_build:
ifneq ($(WITH_DKMS),1)
	@echo Building for $(KVER)
	make clean || true
	make -j$(NJOBS) KVER=$(KVER) K_BUILD=$(K_BUILD)
endif

override_dh_auto_test:

override_dh_auto_install:
ifneq ($(WITH_DKMS),1)
	make install INSTALL_MOD_DIR=$(INSTALL_MOD_DIR) INSTALL_MOD_PATH=$(INSTALL_MOD_PATH) KERNELRELEASE=$(KVER) KVER=$(KVER) K_BUILD=$(K_BUILD)
	find $(INSTALL_MOD_PATH) \( -type f -a -name "modules.*" \) -delete
endif

	# For dkms
ifeq ($(WITH_DKMS),1)
	dh_installdirs -p$(pdkms)  usr/src/$(pname)-$(pversion)
	cp Kconfig debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp makefile debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp Kbuild debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp dkms.conf debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp common.postinst debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp *.c debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp *.h debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp -r scsi debian/$(pdkms)/usr/src/$(pname)-$(pversion)

	# Force DKMS to install our modules.
	# This is mostly needed for modules that do not have a version number info, as DKMS
	# will compare their srcversion field, which does not really say which module is newer.
	dh_installdirs -p$(pdkms)  usr/share/dkms/modules_to_force_install/
	echo "$(pname)" > debian/$(pdkms)/usr/share/dkms/modules_to_force_install/$(pname).force
endif

override_dh_installinit:


ifneq ($(WITH_DKMS),1)
override_dh_gencontrol:
	dh_gencontrol -- -v$(pversion)-$(prel).kver.$(KVER1)
endif

ifneq ($(MLNX_KO_NO_STRIP),1)
ifneq ($(WITH_DKMS),1)
override_dh_strip:
	dh_strip
	find debian -name '*.ko' | xargs strip -g
endif
endif

=== src/ofa_kernel-5.4/drivers/nvme/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# This version is for a hypothetical package that can build a kernel modules
# architecture-dependant package via make-kpkg, as well as an
# architecture-independent module source package, and other packages
# either dep/indep for things like common files or userspace components
# needed for the kernel modules.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

WITH_DKMS ?= 1
MLXNUMC = $(shell grep ^processor /proc/cpuinfo | wc -l)
NJOBS ?= $(shell if [ $(MLXNUMC) -lt 16 ]; then echo $(MLXNUMC); else echo 16; fi)

pname:=mlnx-nvme
psource:=$(pname)-source
ifeq ($(WITH_DKMS),1)
pdkms:=$(pname)-dkms
else
pdkms:=$(pname)-modules
endif

pversion := $(shell dpkg-parsechangelog | sed -n 's/^Version: *\([^-]\+\)-.\+/\1/p')
prel := $(shell dpkg-parsechangelog | sed -n 's/^Version: *\([^-]\+\)-\(.\+\)/\2/p')

export INSTALL_MOD_DIR:=updates
export INSTALL_MOD_PATH:=$(CURDIR)/debian/$(pdkms)

DIST_NAME := $(shell lsb_release -si)
DIST_RELEASE := $(DIST_NAME)/$(shell lsb_release -sc)


KVER ?= $(shell uname -r)
KVER1 = $(shell echo $(KVER) | sed -e 's/_/-/g')
K_BUILD ?= "/lib/modules/$(KVER)/build"

%:
ifeq ($(WITH_DKMS),1)
	dh $@ --with dkms
else
	dh $@
endif

override_dh_auto_clean:

override_dh_auto_configure:

override_dh_auto_build:
ifneq ($(WITH_DKMS),1)
	@echo Building for $(KVER)
	make clean || true
	make -j$(NJOBS) KVER=$(KVER) K_BUILD=$(K_BUILD) CONFIG_NVME_HOST_WITHOUT_FC=
endif

override_dh_auto_test:

override_dh_auto_install:
ifneq ($(WITH_DKMS),1)
	make install INSTALL_MOD_DIR=$(INSTALL_MOD_DIR) INSTALL_MOD_PATH=$(INSTALL_MOD_PATH) KERNELRELEASE=$(KVER) KVER=$(KVER) K_BUILD=$(K_BUILD) CONFIG_NVME_HOST_WITHOUT_FC=
	find $(INSTALL_MOD_PATH) \( -type f -a -name "modules.*" \) -delete
endif

	# For dkms
ifeq ($(WITH_DKMS),1)
	dh_installdirs -p$(pdkms)  usr/src/$(pname)-$(pversion)
	cp makefile debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp Makefile debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp dkms.conf debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp common.postinst debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp -a target debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp -a host debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp -a lpfc debian/$(pdkms)/usr/src/$(pname)-$(pversion)

	# Force DKMS to install our modules.
	# This is mostly needed for modules that do not have a version number info, as DKMS
	# will compare their srcversion field, which does not really say which module is newer.
	dh_installdirs -p$(pdkms)  usr/share/dkms/modules_to_force_install/
	echo "$(pname)" > debian/$(pdkms)/usr/share/dkms/modules_to_force_install/$(pname).force
endif

override_dh_installinit:


ifneq ($(WITH_DKMS),1)
override_dh_gencontrol:
	dh_gencontrol -- -v$(pversion)-$(prel).kver.$(KVER1)
endif

ifneq ($(MLNX_KO_NO_STRIP),1)
ifneq ($(WITH_DKMS),1)
override_dh_strip:
	dh_strip
	find debian -name '*.ko' | xargs strip -g
endif
endif

=== src/ofa_kernel-5.4/net/sunrpc/xprtrdma/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# This version is for a hypothetical package that can build a kernel modules
# architecture-dependant package via make-kpkg, as well as an
# architecture-independent module source package, and other packages
# either dep/indep for things like common files or userspace components
# needed for the kernel modules.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

WITH_DKMS ?= 1
MLXNUMC = $(shell grep ^processor /proc/cpuinfo | wc -l)
NJOBS ?= $(shell if [ $(MLXNUMC) -lt 16 ]; then echo $(MLXNUMC); else echo 16; fi)

pname:=mlnx-nfsrdma
psource:=$(pname)-source
ifeq ($(WITH_DKMS),1)
pdkms:=$(pname)-dkms
else
pdkms:=$(pname)-modules
endif

pversion := $(shell dpkg-parsechangelog | sed -n 's/^Version: *\([^-]\+\)-.\+/\1/p')
prel := $(shell dpkg-parsechangelog | sed -n 's/^Version: *\([^-]\+\)-\(.\+\)/\2/p')

export INSTALL_MOD_DIR:=updates
export INSTALL_MOD_PATH:=$(CURDIR)/debian/$(pdkms)

DIST_NAME := $(shell lsb_release -si)
DIST_RELEASE := $(DIST_NAME)/$(shell lsb_release -sc)


KVER ?= $(shell uname -r)
KVER1 = $(shell echo $(KVER) | sed -e 's/_/-/g')
K_BUILD ?= "/lib/modules/$(KVER)/build"

%:
ifeq ($(WITH_DKMS),1)
	dh $@ --with dkms
else
	dh $@
endif

override_dh_auto_clean:

override_dh_auto_configure:

override_dh_auto_build:
ifneq ($(WITH_DKMS),1)
	@echo Building for $(KVER)
	make clean || true
	make -j$(NJOBS) KVER=$(KVER) K_BUILD=$(K_BUILD)
endif

override_dh_auto_test:

override_dh_auto_install:
ifneq ($(WITH_DKMS),1)
	make install INSTALL_MOD_DIR=$(INSTALL_MOD_DIR) INSTALL_MOD_PATH=$(INSTALL_MOD_PATH) KERNELRELEASE=$(KVER) KVER=$(KVER) K_BUILD=$(K_BUILD)
	find $(INSTALL_MOD_PATH) \( -type f -a -name "modules.*" \) -delete
endif

	# For dkms
ifeq ($(WITH_DKMS),1)
	dh_installdirs -p$(pdkms)  usr/src/$(pname)-$(pversion)
	cp makefile debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp Makefile debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp dkms.conf debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp common.postinst debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp *.c debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp *.h debian/$(pdkms)/usr/src/$(pname)-$(pversion)

	# Force DKMS to install our modules.
	# This is mostly needed for modules that do not have a version number info, as DKMS
	# will compare their srcversion field, which does not really say which module is newer.
	dh_installdirs -p$(pdkms)  usr/share/dkms/modules_to_force_install/
	echo "$(pname)" > debian/$(pdkms)/usr/share/dkms/modules_to_force_install/$(pname).force
endif

override_dh_installinit:


ifneq ($(WITH_DKMS),1)
override_dh_gencontrol:
	dh_gencontrol -- -v$(pversion)-$(prel).kver.$(KVER1)
endif

ifneq ($(MLNX_KO_NO_STRIP),1)
ifneq ($(WITH_DKMS),1)
override_dh_strip:
	dh_strip
	find debian -name '*.ko' | xargs strip -g
endif
endif

=== src/ofa_kernel/default/ofed_scripts/mlnx_en/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# This version is for a hypothetical package that can build a kernel modules
# architecture-dependant package via make-kpkg, as well as an
# architecture-independent module source package, and other packages
# either dep/indep for things like common files or userspace components
# needed for the kernel modules.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

MLX5 ?= 1
MLXFW ?= 1
WITH_DKMS ?= 1
MLXNUMC = $(shell grep ^processor /proc/cpuinfo | wc -l)
NJOBS ?= $(shell if [ $(MLXNUMC) -lt 16 ]; then echo $(MLXNUMC); else echo 16; fi)

WITH_MLXDEVM = $(shell if echo $(MLNX_EN_KERNEL_MODS) | grep -qw mlxdevm; then echo 1; else echo 0; fi)

MLNX_EN_PATCH_PARAMS ?=
ifneq ($(MLX5),1)
	MLNX_EN_PATCH_PARAMS = "$(MLNX_EN_PATCH_PARAMS) --without-mlx5"
endif
ifneq ($(MLXFW),1)
	MLNX_EN_PATCH_PARAMS = "$(MLNX_EN_PATCH_PARAMS) --without-mlxfw"
endif

pname:=mlnx-en
psource:=$(pname)
ifeq ($(WITH_DKMS),1)
pdkms:=$(pname)-dkms
else
pdkms:=$(pname)-modules
endif
putils:=$(pname)-utils

pversion := $(shell dpkg-parsechangelog | sed -n 's/^Version: *\([^-]\+\)-.\+/\1/p')
prel := $(shell dpkg-parsechangelog | sed -n 's/^Version: *\([^-]\+\)-\(.\+\)/\2/p')

export INSTALL_MOD_DIR:=updates
export INSTALL_MOD_PATH:=$(CURDIR)/debian/$(pdkms)

DIST_NAME := $(shell lsb_release -si)
DIST_RELEASE := $(DIST_NAME)/$(shell lsb_release -sc)
kernelver ?= $(shell uname -r)
kernelver1 = $(shell echo $(kernelver) | sed -e 's/_/-/g')
kernel_source_dir ?= "/lib/modules/$(kernelver)/build"

%:
ifeq ($(WITH_DKMS),1)
	dh $@ --with dkms
else
	dh $@
endif

override_dh_auto_clean:

override_dh_auto_configure:
	# backup clean sources
	/bin/rm -rf source || true
	mkdir -p source
	ls -1 | grep -v source | xargs -iELEM cp ELEM -r source
ifneq ($(WITH_DKMS),1)
	@echo Building for $(kernelver)
	find compat -type f -exec touch -t 200012201010 '{}' \; || true
	$(CURDIR)/scripts/mlnx_en_patch.sh --kernel $(kernelver) --kernel-sources $(kernel_source_dir) $(MLNX_EN_PATCH_PARAMS) -j$(NJOBS)
	make -j$(NJOBS)
endif

override_dh_auto_build:
ifneq ($(WITH_DKMS),1)
	make -j$(NJOBS)
endif

override_dh_auto_test:

override_dh_auto_install:
ifneq ($(WITH_DKMS),1)
	make install_modules KSRC=$(kernel_source_dir) KVERSION=$(kernelver) INSTALL_MOD_DIR=$(INSTALL_MOD_DIR) INSTALL_MOD_PATH=$(INSTALL_MOD_PATH) KERNELRELEASE=$(kernelver)
	find $(INSTALL_MOD_PATH) \( -type f -a -name "modules.*" \) -delete
endif

	# For dkms
	dh_installdirs -p$(pdkms)	usr/src/$(pname)-$(pversion)

	cp -a source/LICENSE		debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp -a source/COPYING		debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp -a source/makefile		debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp -a source/Makefile		debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp -a source/backports		debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp -a source/compat*		debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	with_mlx5=$(MLX5) with_mlxfw=$(MLXFW) with_mlxdevm=$(WITH_MLXDEVM) \
	  $(CURDIR)/ofed_scripts/generate_mlnx_en_dkms_conf.sh \
	  > debian/$(pdkms)/usr/src/$(pname)-$(pversion)/dkms.conf
	cp -a source/drivers		debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp -a source/block		debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp -a source/include		debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp -a source/net		debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp -a source/ofed_scripts	debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp -a source/patches		debian/$(pdkms)/usr/src/$(pname)-$(pversion)
	cp -a source/scripts		debian/$(pdkms)/usr/src/$(pname)-$(pversion)

	# Force DKMS to install our modules.
	# This is mostly needed for modules that do not have a version number info, as DKMS
	# will compare their srcversion field, which does not really say which module is newer.
ifeq ($(WITH_DKMS),1)
	dh_installdirs -p$(pdkms)  usr/share/dkms/modules_to_force_install/
	echo "$(pname)" > debian/$(pdkms)/usr/share/dkms/modules_to_force_install/$(pname).force
endif

	# For utils
	dh_installdirs -p$(putils)  etc
	dh_installdirs -p$(putils)  etc/modprobe.d
	dh_installdirs -p$(putils)  etc/init
	dh_installdirs -p$(putils)  etc/init.d
	dh_installdirs -p$(putils)  sbin
	dh_installdirs -p$(putils)  lib/udev
	dh_installdirs -p$(putils)  usr/sbin
	dh_installdirs -p$(putils)  lib/systemd/system

	install -m 0755 source/ofed_scripts/mlnx-bf.conf		debian/$(putils)/etc/modprobe.d
	install -m 0755 source/ofed_scripts/net-interfaces            debian/$(putils)/usr/sbin
	install -m 0644 source/debian/mlnx-en.upstart			debian/$(putils)/etc/init/mlnx-en.conf
	install -m 0755 source/scripts/mlnx-en.d_deb						debian/$(putils)/etc/init.d/mlnx-en.d
	install -m 0644 source/scripts/mlnx-en.conf					debian/$(putils)/etc/mlnx-en.conf
	with_mlx5=$(MLX5) with_mlxfw=$(MLXFW) $(CURDIR)/ofed_scripts/deb_mlnx_en_service_install_helper $(CURDIR)/debian/$(putils)
	install -m 0644 scripts/mlnx-en.d.service			debian/$(putils)/lib/systemd/system

override_dh_installinit:


ifneq ($(WITH_DKMS),1)
override_dh_gencontrol:
	dh_gencontrol -- -v$(pversion)-$(prel).kver.$(kernelver1)
endif

ifneq ($(MLNX_KO_NO_STRIP),1)
ifneq ($(WITH_DKMS),1)
override_dh_strip:
	dh_strip
	find debian -name '*.ko' | xargs strip -g
endif
endif
